unit DialogNastaveni;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  ExtCtrls, Nastaveni;

type

  { TOknoNastaveni }

  TOknoNastaveni = class(TForm)
    dialogBarvy: TColorDialog;
    tlacitkoZmenaBarvyDam: TButton;
    tlacitkoZmenaBarvyCar: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    panelBarvaDam: TPanel;
    panelBarvaCar: TPanel;
    volicPoctuDam: TListBox;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    tlacitkoOK: TButton;
    tlacitkoStorno: TButton;
    PageControl1: TPageControl;
    procedure FormShow(Sender: TObject);
    procedure tlacitkoZmenaBarvyCarClick(Sender: TObject);
    procedure tlacitkoZmenaBarvyDamClick(Sender: TObject);
  private
    procedure setPocetDam(pocet: integer);
    function getPocetDam: integer;
    procedure setBarvaDam(barva: TColor);
    function getBarvaDam: TColor;
    procedure setBarvaCar(barva: TColor);
    function getBarvaCar: TColor;
    procedure zmenaBarvy(panel: TPanel; txt: string);

  public
    property PocetDam: integer read getPocetDam write setPocetDam;
    property BarvaDam: TColor read getBarvaDam write setBarvaDam;
    property BarvaCar: TColor read getBarvaCar write setBarvaCar;
  end;

var
  OknoNastaveni: TOknoNastaveni;

implementation

procedure TOknoNastaveni.FormShow(Sender: TObject);
begin
  PocetDam:=Nastaveni.PocetDam;
  BarvaDam:=Nastaveni.BarvaDam;
  BarvaCar:=Nastaveni.BarvaCar;
end;


procedure TOknoNastaveni.tlacitkoZmenaBarvyCarClick(Sender: TObject);
var barva: TColor;
begin
  zmenaBarvy(panelBarvaCar, 'čar');
end;

procedure TOknoNastaveni.tlacitkoZmenaBarvyDamClick(Sender: TObject);
begin
  zmenaBarvy(panelBarvaDam, 'dam');
end;

procedure TOknoNastaveni.zmenaBarvy(panel: TPanel; txt: string);
begin
  dialogBarvy.Title:='Zvol barvu ' + txt;
  if dialogBarvy.Execute then
  begin
      panel.Color:=dialogBarvy.Color;
  end;
end;

procedure TOknoNastaveni.setPocetDam(pocet: integer);
begin
  volicPoctuDam.Selected[pocet - 4] := true;
end;

function TOknoNastaveni.getPocetDam: integer;
begin
  Result := volicPoctuDam.ItemIndex + 4;
end;

procedure TOknoNastaveni.setBarvaDam(barva: TColor);
begin
  panelBarvaDam.Color:=barva;
end;

function TOknoNastaveni.getBarvaDam: TColor;
begin
  Result := panelBarvaDam.Color;
end;

procedure TOknoNastaveni.setBarvaCar(barva: TColor);
begin
  panelBarvaCar.Color:=barva;
end;

function TOknoNastaveni.getBarvaCar: TColor;
begin
  Result := panelBarvaCar.Color;
end;

{$R *.lfm}

end.

