unit Okno_u;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Menus, ExtCtrls,
  ComCtrls, StdCtrls, LazHelpHTML, damy, Nastaveni, DialogNastaveni, Types,
  LCLIntf, Windows, LMessages;

type

  { TOkno }

  TOkno = class(TForm)
    hlavniMenu: TMainMenu;
    menuIndex: TMenuItem;
    Separator2: TMenuItem;
    prohlizecNapovedy: THTMLBrowserHelpViewer;
    databazeNapovedy: THTMLHelpDatabase;
    napisPostup: TLabel;
    obrazky: TImageList;
    mdenuNova: TMenuItem;
    menuCelkovyPocet: TMenuItem;
    menuDalsiReseni: TMenuItem;
    menuOProgramu: TMenuItem;
    menuNapoveda: TMenuItem;
    menuObnovit: TMenuItem;
    menuUpravit: TMenuItem;
    menuNastaveni: TMenuItem;
    menuKonec: TMenuItem;
    menuUloha: TMenuItem;
    Panel1: TPanel;
    pomocnyPanel: TPanel;
    postup: TProgressBar;
    Separator1: TMenuItem;
    panelNastroju: TToolBar;
    stavovaRadka: TStatusBar;
    Casovac: TTimer;
    tlacitkoNova: TToolButton;
    tlacitkoDalsiReseni: TToolButton;
    tlacitkoCelkovyPocet: TToolButton;
    tlacitkoAnimace: TToolButton;
    ToolButton1: TToolButton;
    procedure CasovacTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure mdenuNovaClick(Sender: TObject);
    procedure menuCelkovyPocetClick(Sender: TObject);
    procedure menuDalsiReseniClick(Sender: TObject);
    procedure menuIndexClick(Sender: TObject);
    procedure menuKonecClick(Sender: TObject);
    procedure menuObnovitClick(Sender: TObject);
    procedure menuOProgramuClick(Sender: TObject);
    procedure menuUpravitClick(Sender: TObject);
    procedure Panel1Paint(Sender: TObject);
    procedure tlacitkoAnimaceClick(Sender: TObject);

  public

  private
    resitel: TResitel;
    jeResitel, jeReseni: Boolean;
    deltax, deltay: integer;
    procedure nakresliSachovnici(plocha: TCanvas; sirka, vyska: integer);
    procedure nakresliDamy(plocha: TCanvas; sirka, vyska: integer);
    procedure povoleniMenu(jak: Boolean);
  public

  end;

var
  Okno: TOkno;

implementation

{$R *.lfm}

type
  TVsechnaReseni = class(TThread)
    zprava: string;
    constructor Create(n: integer);
    procedure Execute; override;
    procedure zobrazZpravu;
  end;

constructor TVsechnaReseni.Create(n: integer);
begin
  inherited Create(true);
end;

procedure TVsechnaReseni.Execute;
var
  lokalniResitel: TResitel;

const
  text1: string = 'Úloha ';
  text2: string = ' dam má ';
  text3: string = ' řešení.'#13#10'Bylo třeba ';
  text4: string = ' pokusů o umístění dámy.' ;
begin
  lokalniResitel := TResitel.Create(Nastaveni.PocetDam);
  lokalniResitel.NajdiVsechnaReseni;
  zprava := text1 + IntToStr(Nastaveni.PocetDam) + text2
            + IntToStr(lokalniResitel.PocetNalezenychReseni) + text3
            + IntToStr(lokalniResitel.PocetVolani) + text4;
  Synchronize(@zobrazZpravu);
  lokalniResitel.Free;
end;

procedure TVsechnaReseni.zobrazZpravu;
begin
  MessageDlg('Celkový počet řešení', zprava, mtInformation, [mbYes], 0);
end;

{ TOkno }

procedure TOkno.menuKonecClick(Sender: TObject);
begin
   Close;
end;

procedure TOkno.menuObnovitClick(Sender: TObject);
begin
  Nastaveni.VychoziNastaveni;
end;

procedure TOkno.menuDalsiReseniClick(Sender: TObject);
begin
   if resitel.NajdiDalsiReseni then
   begin
     jeReseni:=true;
   end else begin
     jeReseni:=false;
     resitel.Free;
     jeResitel := false;
     Application.MessageBox('Další řešení neexistují', 'Upozornění');
     povoleniMenu(false);
   end;
   Repaint;
end;

procedure TOkno.menuIndexClick(Sender: TObject);
var cesta: string;
begin
   cesta := ExtractFilePath(Application.ExeName) + 'html\index.html';
   OpenURL(cesta);
end;

procedure TOkno.mdenuNovaClick(Sender: TObject);
begin
  resitel := TResitel.Create(Nastaveni.PocetDam);
  jeResitel:=true;
  postup.Max:=Nastaveni.PocetDam;
  povoleniMenu(true);
  Repaint;
end;

procedure TOkno.menuCelkovyPocetClick(Sender: TObject);
var
  {lokalniResitel: TResitel;
  aktualniRadka: integer = 0;  }
  vlakno: TVsechnaReseni;
{const
  text1: string = 'Úloha ';
  text2: string = ' dam má ';
  text3: string = ' řešení.'#13#10'Bylo třeba ';
  text4: string = ' pokusů o umístění dámy.' ;      }

begin
  {lokalniResitel := TResitel.Create(Nastaveni.PocetDam);
  //lokalniResitel.NajdiVsechnaReseni;
  pomocnyPanel.Visible:=true;
  while lokalniResitel.NajdiDalsiReseni do
  begin
     if lokalniResitel.Reseni[0] > aktualniRadka then
     begin
       aktualniRadka:=lokalniResitel.Reseni[0];
       postup.Position:=aktualniRadka;
       stavovaRadka.SimpleText:='Jsme na ' + IntToStr(aktualniRadka) + '. řádce.';;
     end;
  end;
  postup.Position:=Nastaveni.PocetDam;
  zprava := text1 + IntToStr(Nastaveni.PocetDam) + text2
            + IntToStr(lokalniResitel.PocetNalezenychReseni) + text3
            + IntToStr(lokalniResitel.PocetVolani) + text4;
  MessageDlg('Celkový počet řešení', zprava, mtInformation, [mbYes], 0);
  postup.Position:=0;
  lokalniResitel.Free;
  stavovaRadka.SimpleText:='';
  pomocnyPanel.Visible:=false; }
  vlakno := TVsechnaReseni.Create(Nastaveni.PocetDam);
  vlakno.FreeOnTerminate:=true;
  vlakno.Start;
end;

procedure TOkno.FormCreate(Sender: TObject);
begin
  jeResitel:=false;
  jeReseni:=false;
  postup.Position:=0;
  pomocnyPanel.Visible:=false;
  povoleniMenu(false);
end;

procedure TOkno.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if MessageDlg('Dotaz', 'Opravdu chceš skončit?', mtConfirmation, mbYesNo, 0) = mrNo then
  begin
    CanClose:=false;
  end;
end;

procedure TOkno.CasovacTimer(Sender: TObject);
begin
    jeReseni:=true;
    if not resitel.NajdiDalsiReseni then
    begin
       resitel.Free;
       resitel := TResitel.Create(Nastaveni.PocetDam);
       resitel.NajdiDalsiReseni;
    end;
    Repaint;
end;


procedure TOkno.menuOProgramuClick(Sender: TObject);
begin
  Application.MessageBox('Program na řešení úlohy N dam'#13#10'(c) Piškvorky software 2025', 'O p rogramu');
end;

procedure TOkno.menuUpravitClick(Sender: TObject);
begin
  if OknoNastaveni.ShowModal = mrOk then
  begin
    Nastaveni.PocetDam:=OknoNastaveni.PocetDam;
    Nastaveni.BarvaDam:=OknoNastaveni.BarvaDam;
    Nastaveni.BarvaCar:=OknoNastaveni.BarvaCar;
  end;
end;

procedure TOkno.Panel1Paint(Sender: TObject);
begin
   if jeResitel then
   begin
     nakresliSachovnici(Panel1.Canvas, Panel1.Width, panel1.Height);
     if jeReseni then
     begin
       nakresliDamy(Panel1.Canvas, Panel1.Width, panel1.Height)
     end;
   end;
end;

procedure TOkno.tlacitkoAnimaceClick(Sender: TObject);
begin
  if casovac.Enabled then
  begin
    Casovac.Enabled:=false;
    tlacitkoAnimace.ImageIndex:=3;
  end else begin
    tlacitkoAnimace.ImageIndex:=4;
    Casovac.Enabled:=true;
  end;
end;


procedure TOkno.nakresliSachovnici(plocha: TCanvas; sirka, vyska: integer);
var i: integer;
begin
   deltax := sirka div Nastaveni.PocetDam;
   deltay := vyska div Nastaveni.PocetDam;
   plocha.Pen.Width:=1;
   plocha.Pen.Color:=Nastaveni.BarvaCar;

   for i := 0 to Nastaveni.PocetDam do
   begin
     plocha.Line(0, deltay*i, sirka, deltay*i);
     plocha.Line(i*deltax, 0, i*deltax, vyska);
   end;
end;

procedure TOkno.nakresliDamy(plocha: TCanvas; sirka, vyska: integer);
var
  i, j: integer;
const delta = 5;
begin
   plocha.Pen.Width:=1;
   plocha.Pen.Color:=Nastaveni.BarvaDam;
   plocha.Brush.Color:=Nastaveni.BarvaDam;
   for i := 0 to Nastaveni.PocetDam - 1 do
   begin
     j := resitel.Reseni[i];
     plocha.Ellipse(i*deltax + delta, j*deltay + delta, (i+1)*deltax - delta, (j+1)*deltay - delta);
   end;
end;

procedure TOkno.povoleniMenu(jak: Boolean);
begin
   menuDalsiReseni.Enabled:=jak;
   tlacitkoDalsiReseni.Enabled:=jak;
   menuCelkovyPocet.Enabled := jak;
   tlacitkoCelkovyPocet.Enabled:=jak;
end;

end.

